when ELSE rule exists in Styling, all Labels are rendered regardless of styling groups being 
Status: Closed

Priority: High

Assignee: Jürgen Fischer

Category: Labelling

Affected QGIS version:master Regression?: No

Operating System: Debian Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 21668

Description

If a layer using rule-based styling is active and has an ELSE rule (commit:02ed712), then all the labels are rendered even though all the

subgroups (including the ELSE rule) are set inactive.

Also, if one of the styling groups is inactive, labels are rendered for the features that fit the styling, and they shouldn't.

Associated revisions

Revision ea0ce4ec - 2015-10-21 09:45 PM - Jürgen Fischer

rule based renderer: keep skip else rule if an inactive rule matches, but still return if the feature was actually rendered so that only rendered features are

labeled (fixes #13631)

Revision d6f66ee4 - 2015-10-23 04:04 PM - Jürgen Fischer

fix phantom labels for (actually not) rendered feature (refs #13631)

Revision bfd29333 - 2015-10-23 07:19 PM - Jürgen Fischer

fix phantom labels for (actually not) rendered feature (refs #13631)

(cherry picked from commit d6f66e & b36cd1f)

History

#1 - 2015-10-20 02:42 AM - Tudor Bărăscu

2.8 LTR has the same issue.

#2 - 2015-10-21 12:46 PM - Jürgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"ea0ce4ec1ede1342795544bf42a1bdd766d66cec".

#3 - 2015-10-22 02:35 AM - Andreas Neumann
- File test_labeling_with_else_rules.zip added

Thank you Jürgen for havinb a look at this.

However, I still have issues where labels are shown and the geometry is not shown.

Maybe an issue with ELSE rules combined with scale rules?

Demoproject uploaded. Project contains two layers - one without ELSE rule (behaves as expected), one with ELSE rule where labels are sometimes shown

when they should't be shown.

#4 - 2015-10-22 03:08 AM - Jürgen Fischer

- Assignee set to Jürgen Fischer

#5 - 2015-10-22 03:40 AM - Tudor Bărăscu

- File styling_bug.zip added

Bug example data

--------------------

In this example, the pipe geometry is rendered between 1:501 and 1:5001 but the labels are rendered at every scale, which shouldn't happen.

#6 - 2015-10-24 09:34 AM - Tudor Bărăscu

Thanks a lot for solving it Jürgen.

Files

pic.png 18.8 KB 2015-10-19 Tudor Bărăscu

test_labeling_with_else_rules.zip 173 KB 2015-10-22 Andreas Neumann

styling_bug.zip 6.57 KB 2015-10-22 Tudor Bărăscu
